<?php /*
Plugin Name: StopBadBots
Plugin URI: http://stopbadbots.com
Description: The easiest way to stop bad bots and spiders.
Version: 5.42
Text Domain: stopbadbots
Domain Path: /language
Author: Bill Minozzi
Author URI: http://stopbadbots.com
License:     GPL2
Copyright (c) 2016 Bill Minozzi
Stopbadbots is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 2 of the License, or
any later version.
StopBadBots_optin is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with StopBadBots_optin. If not, see {License URI}.
Permission is hereby granted, free of charge subject to the following conditions:
The above copyright notice and this FULL permission notice shall be included in
all copies or substantial portions of the Software.
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
DEALINGS IN THE SOFTWARE.
 */
if (!defined('ABSPATH')) {
    exit;
}
// Exit if accessed directly
//ob_start();
define('STOPBADBOTSVERSION', '5.42');
define('STOPBADBOTSPATH', plugin_dir_path(__file__));
define('STOPBADBOTSURL', plugin_dir_url(__file__));
define('STOPBADBOTSDOMAIN', get_site_url());
define('STOPBADBOTSIMAGES', plugin_dir_url(__file__) . 'assets/images');
$stopbadbotsserver = sanitize_text_field($_SERVER['SERVER_NAME']);
if(!function_exists('wp_get_current_user')) {
    require_once(ABSPATH . "wp-includes/pluggable.php"); 
}

add_filter( 'plugin_action_links_' . plugin_basename(__FILE__), 'stopbadbots_add_action_links' );
function stopbadbots_add_action_links ( $links ) {
 $mylinks = array(
 '<a href="' . admin_url( 'admin.php?page=settings-stop-bad-bots' ) . '">Settings</a>',
 );
return array_merge( $links, $mylinks );
}



/* Begin Language */
if ( is_admin() or is_super_admin()) {
    function stop_localization_init_fail()
    {
        // echo '<div class="error notice"><br />';
        echo '<div class="notice notice-warning is-dismissible">';
        echo '<br />';
        echo __('Stop Bad Bots: Could not load the localization file (Language file)', 'stopbadbots');
        echo '.<br />';
        echo __('Please, take a look in our site, the online Guide, item => Plugin Language', 'stopbadbots');
        echo '.<br /><br /></div>';
    }
    if (isset($_GET['page'])) {
        $page = sanitize_text_field($_GET['page']);
        if ($page == 'stop_bad_bots_plugin' or $page == 'sbb_my-custom-submenu-page') {
            $path = dirname(plugin_basename(__FILE__)) . '/language/';
            $loaded = load_plugin_textdomain('stopbadbots', false, $path);
            if (!$loaded and get_locale() != 'en_US') {
                // if( function_exists('stop_localization_init_fail'))
                //   add_action( 'admin_notices', 'stop_localization_init_fail' );
            }
        }
    }
} else {
    add_action('plugins_loaded', 'stop_localization_init');
}
function stop_localization_init()
{
    $path = dirname(plugin_basename(__FILE__)) . '/language/';
    $loaded = load_plugin_textdomain('stopbadbots', false, $path);
}
/* End language */
require_once STOPBADBOTSPATH . "settings/load-plugin.php";
require_once STOPBADBOTSPATH . "functions/functions.php";
require_once ABSPATH . 'wp-includes/pluggable.php';
if (!class_exists('WP_List_Table')) {
    require_once ABSPATH . 'wp-admin/includes/class-wp-list-table.php';
}
require dirname(__FILE__) . '/includes/list-tables/class-sbb-list-table.php';
require dirname(__FILE__) . '/includes/list-tables/class-sbb-list-table2.php';
require dirname(__FILE__) . '/includes/list-tables/class-sbb-list-table3.php';
$stopbadbots_checkversion = sanitize_text_field(get_option('stopbadbots_checkversion', ''));
$stopbadbots_checkversion = trim($stopbadbots_checkversion);
$stop_bad_bots_firewall = sanitize_text_field(get_option('stop_bad_bots_firewall', 'yes'));
if ($stopbadbots_checkversion != '') {
    $stop_bad_bots_firewall = strtolower($stop_bad_bots_firewall);
} else {
    $stop_bad_bots_firewall = 'no';
}
require_once STOPBADBOTSPATH . 'dashboard/main.php';
require_once STOPBADBOTSPATH . "settings/load-plugin.php";
require_once STOPBADBOTSPATH . "settings/options/plugin_options_tabbed.php";
if (is_admin() or is_super_admin()) {
    function stopbadbots_add_admstylesheet()
    {
        wp_enqueue_script('flot', STOPBADBOTSURL .
            'assets/js/jquery.flot.min.js', array('jquery'));
    }
    add_action('admin_enqueue_scripts', 'stopbadbots_add_admstylesheet', 1000);
}
add_action('admin_menu', 'sbb_add_menu_items');
add_filter('set-screen-option', 'stopbadbots_set_screen_options', 10, 3);
$stopbadbotsip = sbb_findip();
// $stopbadbotsip = '101.4.136.34';
$userAgentOri = sbb_get_ua();
// $userAgentOri = '';

$userAgent = strtolower(trim(strtolower($userAgentOri)));
// $userAgent = 'Acoon';
$stop_bad_bots_active = sanitize_text_field(get_option('stop_bad_bots_active', 'yes'));
$stop_bad_bots_active = strtolower($stop_bad_bots_active);
$stop_bad_bots_ip_active = sanitize_text_field(get_option('stop_bad_bots_ip_active', 'yes'));
$stop_bad_bots_ip_active = strtolower($stop_bad_bots_ip_active);
$stop_bad_bots_referer_active = sanitize_text_field(get_option('stop_bad_bots_referer_active', 'yes'));
$stop_bad_bots_referer_active = strtolower($stop_bad_bots_referer_active);
//Report Firewall
$stopbadbots_Report_Blocked_Firewall = sanitize_text_field(get_option('stopbadbots_Blocked_Firewall', 'no'));
$stopbadbots_Report_Blocked_Firewall = strtolower($stopbadbots_Report_Blocked_Firewall);
// Report All
$stopbadbots_my_radio_report_all_visits = sanitize_text_field(get_option('stopbadbots_my_radio_report_all_visits', 'no'));
$stopbadbots_my_radio_report_all_visits = strtolower($stopbadbots_my_radio_report_all_visits);
$stop_bad_bots_network = sanitize_text_field(get_option('stop_bad_bots_network', 'yes'));
$stop_bad_bots_network = strtolower($stop_bad_bots_network);


$stop_bad_bots_blank_ua = sanitize_text_field(get_option('stop_bad_bots_blank_ua', 'no'));
$stop_bad_bots_blank_ua = strtolower($stop_bad_bots_blank_ua);

/*
$stop_bad_bots_blank_ua = sanitize_text_field(get_option('stop_bad_bots_blank_ua', 'no'));
$stop_bad_bots_blank_ua = strtolower($stop_bad_bots_blank_ua);
*/


$stopbadbots_version = trim(sanitize_text_field(get_site_option('stopbadbots_version', '')));
$sbb_admin_email = trim(get_option('stopbadbots_my_email_to'));
if (!empty($sbb_admin_email)) {
    if (!is_email($sbb_admin_email)) {
        $sbb_admin_email = '';
        update_option('stopbadbots_my_email_to', '');
    }
}
if (empty($sbb_admin_email)) {
    $sbb_admin_email = sanitize_text_field(get_option('admin_email'));
}
// Firewall
if (!is_admin() and !is_super_admin()) {
    if ($stop_bad_bots_firewall != 'no' and $stopbadbots_checkversion != '') {
        $stopbadbots_request_uri_array = array('@eval', 'eval\(', 'UNION(.*)SELECT', '\(null\)', 'base64_', '\/localhost', '\%2Flocalhost', '\/pingserver', 'wp-config\.php', '\/config\.', '\/wwwroot', '\/makefile', 'crossdomain\.', 'proc\/self\/environ', 'usr\/bin\/perl', 'var\/lib\/php', 'etc\/passwd', '\/https\:', '\/http\:', '\/ftp\:', '\/file\:', '\/php\:', '\/cgi\/', '\.cgi', '\.cmd', '\.bat', '\.exe', '\.sql', '\.ini', '\.dll', '\.htacc', '\.htpas', '\.pass', '\.asp', '\.jsp', '\.bash', '\/\.git', '\/\.svn', ' ', '\<', '\>', '\/\=', '\.\.\.', '\+\+\+', '@@', '\/&&', '\/Nt\.', '\;Nt\.', '\=Nt\.', '\,Nt\.', '\.exec\(', '\)\.html\(', '\{x\.html\(', '\(function\(', '\.php\([0-9]+\)', '(benchmark|sleep)(\s|%20)*\(', 'indoxploi', 'xrumer');
        $stopbadbots_query_string_array = array('@@', '\(0x', '0x3c62723e', '\;\!--\=', '\(\)\}', '\:\;\}\;', '\.\.\/', '127\.0\.0\.1', 'UNION(.*)SELECT', '@eval', 'eval\(', 'base64_', 'localhost', 'loopback', '\%0A', '\%0D', '\%00', '\%2e\%2e', 'allow_url_include', 'auto_prepend_file', 'disable_functions', 'input_file', 'execute', 'file_get_contents', 'mosconfig', 'open_basedir', '(benchmark|sleep)(\s|%20)*\(', 'phpinfo\(', 'shell_exec\(', '\/wwwroot', '\/makefile', 'path\=\.', 'mod\=\.', 'wp-config\.php', '\/config\.', '\$_session', '\$_request', '\$_env', '\$_server', '\$_post', '\$_get', 'indoxploi', 'xrumer');
        $stopbadbots_request_uri_string = false;
        $stopbadbots_query_string_string = false;
        if (isset($_SERVER['REQUEST_URI']) && !empty($_SERVER['REQUEST_URI'])) {
            $stopbadbots_request_uri_string = $_SERVER['REQUEST_URI'];
        }
        if (isset($_SERVER['QUERY_STRING']) && !empty($_SERVER['QUERY_STRING'])) {
            $stopbadbots_query_string_string = $_SERVER['QUERY_STRING'];
        }
        if ($stopbadbots_request_uri_string || $stopbadbots_query_string_string) {
            if (
                preg_match('/' . implode('|', $stopbadbots_request_uri_array) . '/i', $stopbadbots_request_uri_string, $matches) ||
                preg_match('/' . implode('|', $stopbadbots_query_string_array) . '/i', $stopbadbots_query_string_string, $matches2)
            ) {
                sbb_stats_moreone('qfire');
                if ($stopbadbots_Report_Blocked_Firewall == 'yes') {
                    if (isset($matches)) {
                        if (is_array($matches)) {
                            if (count($matches) > 0) {
                                sbb_alertme3($matches[0]);
                            }
                        }
                    }
                    if (isset($matches2)) {
                        if (is_array($matches2)) {
                            if (count($matches2) > 0) {
                                sbb_alertme3($matches2[0]);
                            }
                        }
                    }
                }
                stopbadbots_response();
                // wp_die("");
            } // Endif match...
        } // endif if ($stopbadbots_query_string_string || $user_agent_string)
    } // firewall <> no
}
if (!empty($userAgent) and !is_admin()  and  !is_super_admin()          ) {
    if (sbbcrawlerDetect($userAgent) and $stop_bad_bots_active != 'no') {
        sbbmoreone($userAgentOri); // +1
        sbb_stats_moreone('qnick');
        if ($stopbadbots_my_radio_report_all_visits == 'yes') {
            sbb_alertme($userAgentOri);
        }
        sbb_complete_bot_data($sbb_found);
        if ($stop_bad_bots_network != 'no') {
            upload_new_bots();
        }
        exit;
        stopbadbots_response();
        //wp_die();
    }
}
if (!empty($stopbadbotsip) and !is_admin() and !is_super_admin()) {
    if (sbbvisitoripDetect($stopbadbotsip) and $stop_bad_bots_ip_active != 'no') {
        sbbmoreone2($stopbadbotsip); // +1
        sbb_stats_moreone('qip');
        if ($stopbadbots_my_radio_report_all_visits == 'yes') {
            sbb_alertme2($stopbadbotsip);
        }
        stopbadbots_response();
        // wp_die();
    }
}
function sbb_render_list_page()
{
    $test_list_table = new sbb_List_Table();
    $test_list_table->sbb_prepare_items();
    require dirname(__FILE__) . '/includes/list-tables/page.php';
}
function sbb_render_list_page2()
{
    $stopbadbots_list_table2 = new sbb_List_Table2();
    $stopbadbots_list_table2->sbb_prepare_items2();
    require dirname(__FILE__) . '/includes/list-tables/page2.php';
}
function sbb_render_list_page3()
{
    $stopbadbots_list_table3 = new sbb_List_Table3();
    $stopbadbots_list_table3->sbb_prepare_items3();
    require dirname(__FILE__) . '/includes/list-tables/page3.php';
}
register_activation_hook(__FILE__, 'sbb_plugin_was_activated');
if ($stopbadbots_version < STOPBADBOTSVERSION) {
    // Version was changed - Update made.
    if ($stopbadbots_version < '5.42') {
        sbb_create_db();
        sbb_upgrade_db();
        sbb_create_db2();
        sbb_upgrade_db2();
        sbb_create_db3();
        // sbb_upgrade_db3();
        sbb_create_db_stats();
        sbb_upgrade_stats();
        check_db_sbb_blacklist();
        sbb_fill_db_froma();
        sbb_fill_db_froma2();
        sbb_fill_db_froma3();
    } else {
        sbb_fill_db_froma();
        sbb_fill_db_froma2();
        sbb_fill_db_froma3();
        sbb_create_db_stats();
        sbb_populate_stats();
    }
    //Default yes
    if (sanitize_text_field(get_option('stop_bad_bots_network', '') == '')) {
        add_option('stop_bad_bots_network', 'yes');
    }
    if (!add_option('stopbadbots_version', STOPBADBOTSVERSION)) {
        update_option('stopbadbots_version', STOPBADBOTSVERSION);
    }
}
add_action('admin_menu', 'sbb_add_admin_menu');
add_action('admin_menu', 'sbb_add_admin_menu2');
add_action('admin_menu', 'sbb_add_admin_menu3');
add_action('admin_init', 'sbb_settings_init');
add_action('admin_init', 'sbb_settings2_init');
add_action('admin_init', 'sbb_settings3_init');
function stopbadbots_load_feedback()
{
    if (is_admin() or is_super_admin() ) {
        require_once STOPBADBOTSPATH . "includes/feedback/feedback.php";
        if (sanitize_text_field(get_option('bill_last_feedback', '') != '1')) {
            require_once STOPBADBOTSPATH . "includes/feedback/feedback-last.php";
        }
    }
}
add_action('wp_loaded', 'stopbadbots_load_feedback');
function stopbadbots_load_activate()
{
    if (is_admin() or is_super_admin()) {
        require_once STOPBADBOTSPATH . 'includes/feedback/activated-manager.php';
    }
}
add_action('in_admin_footer', 'stopbadbots_load_activate');
//$buffer = ob_get_flush();
add_action('admin_menu', 'sbb_add_menu_items9');
function sbb_custom_dashboard_help()
{
    echo '<img src="' . STOPBADBOTSURL . '/images/logo.png" style="text-align:center; max-width: 200px;margin: 0px 0 auto;"  />';
    echo '<br />';
    echo '<br />';
    require_once "dashboard/topbots.php";
    echo '<br />';
    echo '<hr>';
    echo '<br />';
    require_once "dashboard/topips.php";
    echo '<br />';
    echo '<br />';
    $site = STOPBADBOTSHOMEURL . "admin.php?page=stop_bad_bots_plugin";
    $bd_msg = '<a href="' . $site . '" class="button button-primary">Details</a>';
    $bd_msg .= '<br /><br />';
    echo $bd_msg;
    echo "</p>";
}
function sbb_add_dashboard_widgets()
{
    wp_add_dashboard_widget('stopbadbots-dashboard', 'Stop Bad Bots Activities', 'sbb_custom_dashboard_help', 'dashboardsbb', 'normal', 'high');
}
add_action("wp_dashboard_setup", "sbb_add_dashboard_widgets");
// Bad Referer
if (sanitize_text_field(get_option('stop_bad_bots_referer_active', '') != 'no')) {
    if(isset($_SERVER['HTTP_REFERER']))
       $referer = strip_tags($_SERVER['HTTP_REFERER']);
    else
       $referer = ''; //1apple.com';
    $badreferer = '';
    if (sbbReferDetect()) {
        Global $badreferer;
        sbbmoreone4($badreferer); // +1
        sbb_stats_moreone('qref');
        if ($stopbadbots_my_radio_report_all_visits == 'yes') {
            sbb_alertme4($badreferer);
        }
        /*
        if($stop_bad_bots_network != 'no')
        upload_new_badreferer();
        exit;
         */
        stopbadbots_response();
    }
}

if ( $stop_bad_bots_blank_ua == 'yes' and !is_admin() and !is_super_admin()) {
   

    if(empty(trim($userAgentOri)))
    {

        sbb_stats_moreone('qua');
        if ($stopbadbots_my_radio_report_all_visits == 'yes') {
            sbb_alertme5();
        }
        stopbadbots_response();
    }
}?>